/* 
    Arquivo js para a configuracaodo teclado
 */


var zooming = false;
var pan = false;

function quatToRot(q)
{
  var qX = q[0];
  var qY = q[1];
  var qZ = q[2];
  var qW = q[3];

  var qWqW = qW * qW;
  var qWqX = qW * qX;
  var qWqY = qW * qY;
  var qWqZ = qW * qZ;
  var qXqW = qX * qW;
  var qXqX = qX * qX;
  var qXqY = qX * qY;
  var qXqZ = qX * qZ;
  var qYqW = qY * qW;
  var qYqX = qY * qX;
  var qYqY = qY * qY;
  var qYqZ = qY * qZ;
  var qZqW = qZ * qW;
  var qZqX = qZ * qX;
  var qZqY = qZ * qY;
  var qZqZ = qZ * qZ;

  var d = qWqW + qXqX + qYqY + qZqZ;

  return [
    (qWqW + qXqX - qYqY - qZqZ) / d,
     2 * (qWqZ + qXqY) / d,
     2 * (qXqZ - qWqY) / d, 0,

     2 * (qXqY - qWqZ) / d,
     (qWqW - qXqX + qYqY - qZqZ) / d,
     2 * (qWqX + qYqZ) / d, 0,

     2 * (qWqY + qXqZ) / d,
     2 * (qYqZ - qWqX) / d,
     (qWqW - qXqX - qYqY + qZqZ) / d, 0,

     0, 0, 0, 1];
}

function rot(axis, angle)
{
    
            //var axis = vec3.fromValues(0,1,0);
            /*
            var inv  = mat3.create();
            
            var mvMatrix = mat4.create();
            mat4.multiply(mvMatrix, vMatrix, mMatrix);
            
            mat4.multiply(mvMatrix, pMatrix, mvMatrix);
            
            mat3.fromMat4(inv, mvMatrix);
            
            mat3.invert(inv, inv);
            */
            
            var rotQuat = quat.create();
            quat.setAxisAngle(rotQuat, axis, angle);
            var rm = quatToRot(rotQuat);
            
            
            /*
            axis[0] = axis[0] * inv[0] + axis[1] * inv[1] + axis[2] * inv[2];
            axis[1] = axis[0] * inv[3] + axis[1] * inv[4] + axis[2] * inv[5];
            axis[2] = axis[0] * inv[6] + axis[1] * inv[7] + axis[2] * inv[8];
            vec3.normalize(axis, axis);*/
           // document.getElementById("debug").innerHTML = "Axis: " + vecToStr(axis) + "<br>";
            //mat4.rotate(mMatrix, mMatrix, angle, axis);
            mat4.multiply(mMatrix, rm, mMatrix);
}

function keyLeave(event)
{
    var code = event.keyCode;
    if(code == 17)
    {
        zooming = false;
        zoomLastY = 0;
        zoomCurrentY = 0;
    }
    else if(code == 16)
    {
        pan = false;
        panLastPos[0] = 0;
        panLastPos[1] = 0;
        panCurrentPos[0] = 0;
        panCurrentPos[1] = 0;
    }

}
function keyboard(event)
{
    
    var code = event.keyCode;
    
    //TODO: trocar por control.
    var ch = String.fromCharCode(event.keyCode);
    //document.getElementById("debug").innerHTML="CH " + ch + " CODE: " + code +"<br>";
    
    
    switch(code)
    {
        
        case 37://left arrow
        {
            var axis = vec3.fromValues(0,1,0);
            rot(axis, -0.1);
            break;
        }
        case 38://up
        {
            var axis = vec3.fromValues(1,0,0);
            rot(axis,-0.1);
            //mat4.rotate(vMatrix, vMatrix, -0.1, [1,0,0]);
            break;
        }
        case 39://rght
        {
            var axis = vec3.fromValues(0,1,0);
            rot(axis,0.1);
            break;
        }
        case 40: //down
        {
            
            var axis = vec3.fromValues(1,0,0);
            rot(axis,0.1);
            break;
        }
        case 17://left ctrl
        {
            zooming = true;
            zoomLastY = 0;
            zoomCurrentY = 0;
            break;
        }
        case 16: //shift
        {
            pan = true;
            break;
        }
        case 82://R
        {
            //reset cam pos
            eyeXY[0] = 0;
            eyeXY[1] = 0;
            vPos = 2;
            mat4.lookAt(vMatrix,[eyeXY[0],eyeXY[1],vPos], [eyeXY[0],eyeXY[1],0],[0,1,0]);
            break;
        }
    }
}

