<?PHP
 /*ARQUIVO RETIRADO DO LINK http://www.novateceditora.com.br/livros/phpmysql/CodigosFontesLivroPhp.zip
   CRIADO POR ANDR MILANI - EDITORA NOVATEC
  ACESSADO EM 17/10/2015 AS 20H
  */
  abstract class BancoDeDados
  {
    /*
    * Esta classe abstrata define os mtodos que as classes que a herdarem
    * devem implementar de forma concreta, padronizando os nomes dos mtodos
    * independente do banco de dados a ser implementado / utilizado.        
    */
        
    protected $server;    // Armazena o endereo do servidor
    protected $port;      // Armazena a porta de conexo
    protected $user;      // Armazena o nome de usurio para conexo
    protected $password;  // Armazena a senha de usurio para conexo
    protected $db;        // Armazena o nome do banco de dados
    protected $connection;  // Armazena os dados de uma conexo
    protected $resultSet;   // Armazena o ResultSet de uma consulta
  
    /* Define os dados de conexo com o banco de dados */         
    abstract public function setConfig($server, $port, $user, $password, $db);
    
    /* Conecta ao banco de dados */         
    abstract public function connect();
    
    /* Desconecta do banco de dados */
    abstract public function disconnect();
        
    /* Executa comandos sql */
    abstract public function executeCommand($sql);
    
    /* Retorna o prximo result set da consulta */
    abstract public function getNextResultSetPosition();
    
    /* Retorna o nmero de registros do ltimo comando realizado */
    abstract public function getAffectedRows();
    
    /* Retorna se ocorreu algum erro no ltimo comando realizado */
    abstract public function getError();
  }
  
?>
