<?PHP require "verifica.php"; 
include_once("MySQL.php");
include_once("Utils.php");


$shader = isset($_GET['shader']) ? $_GET['shader'] : 'phong';
$malha = isset($_GET['malha']) ? $_GET['malha'] : '';
$utils = new Utils();
$database = $utils->getDatabaseConnection();
$database->connect();

$resultado = $database->executeCommand("SELECT * FROM MALHAS 
                            WHERE USUARIO = ".$_SESSION["id"]);

if (!$resultado)
    $qtde = $database->getAffectedRows();

if (!empty($_SESSION["mensagem"]) || isset($_SESSION["mensagem"]))
{
     echo"<script type='text/javascript'>";
     echo "alert('".$_SESSION["mensagem"]."');";
     echo "</script>";
     unset($_SESSION["mensagem"]);
}

?>
<!DOCTYPE html>
<!--
View model
-->
<html>
    <head>
    <meta name="description" content="Banca da disciplina de Projeto Final de Curso II, apresentada ao Curso de Sistemas de
    Informação da Universidade Estadual de Mato Grosso do Sul, como parte dos requisitos para a obtenção do título de Bacharel em Sistemas de Informação.">
    <meta name="author" content="Allan Henrique Paza">
    <link rel="icon" href="../favicon.ico">

    <title>Aplicações WEB 3D com WEBGL: Visualizador de Malhas</title>
        <meta charset="UTF-8">
        <link rel="stylesheet" type="text/css" href="../css/viewer.css">

            <!-- Bootstrap core CSS -->
        <link href="../css/bootstrap.css" rel="stylesheet">
        <link href="../css/main.css" rel="stylesheet">
        <link href="../css/stylish-portfolio.css" rel="stylesheet">
        <link href="../font-awesome/css/font-awesome.min.css" rel="stylesheet">
        <link href="../css/cover.css" rel="stylesheet">
        
    </head>
    <body >
       
        <!-- Fixed navbar -->
    <div class="navbar navbar-default navbar-fixed-bottom">
      <div class="container-fluid">
        <div class="col-xs-4">
            <p class="text-right">
            <?PHP echo "Olá ".$_SESSION["nome"]."!";?>
            </p>
        </div>
        <div class="col-xs-4">
            
        </div>
        <div class="col-xs-4">
            <a id="sair" href="sair.php">Sair</a>
        </div>
      </div>
    </div>

        <!-- Side Menu -->
    <a id="menu-toggle" href="#" class="btn btn-primary btn-lg toggle"><i class="fa fa-bars"></i></a>
    <div id="sidebar-wrapper">
        <ul class="sidebar-nav">
            <a id="menu-close" href="#" class="btn btn-default btn-lg pull-right toggle"><i class="fa fa-times"></i></a>
            <li class="sidebar-brand"><img src="../logo_uems2.png"  id="logo"> <!-- <a href="#">SAE online</a> -->
            <li><a href="#menu">Carregar Modelo...</a></li>
             <li><a href="#menu">Shaders:</a>
                        <ul>
                            <li><a href="viewer.php?shader=flat&malha=<?php echo $malha;?>">Flat</a></li>
                            <li><a href="viewer.php?shader=phong&malha=<?php echo $malha;?>">Phong</a></li>
                            <li><a href="viewer.php?shader=passtru&malha=<?php echo $malha;?>">Pass-thru</a></li>
                         </ul>
            </li>
            <li><a href="#menu">Meus modelos:</a>
            <ul>
             <?php if ($qtde > 0) {
                $malha = $database->getNextResultSetPosition();
                $i = 0;
                for ($i = 0; $i<$qtde;$i++) 
                {
                    $nome = explode(".",$malha["2"]);
                ?>
                    <li><a href="viewer.php?shader=<?php echo $shader;?>&malha=<?php echo $_SESSION["id"]."_".$malha["2"]; ?>"><?php echo $nome[0];?></a></li>

            <?php $malha = $database->getNextResultSetPosition();}}else {?>
                        
                            <li><a href="#">Você não tem malhas...</a></li>
                            
                            
                         
            <?php }?>
            </ul>
            </li>
            
        </ul>
        
    </div>
    <!-- /Side Menu -->
        
    <div id="site2">
    <div class="col-md-12">
                <form class="form-horizontal" method="post" id="formPadrao" enctype="multipart/form-data" action="upload.php">
                    <fieldset>
                        <legend class="text-center header" id="titulo">Carregar Malha</legend>

                       
                        <div class="form-group">
                            <span class="col-md-1 col-md-offset-2 text-center"><i class="fa fa-upload bigicon"></i></span>
                            <div class="col-md-8">
                                <input id="arquivo" name="arquivo" type="file" placeholder="Selecione" class ="form-control">
                            </div>
                        </div>


                        <input id="acao" name="acao" type="hidden" value="carregar">
                       

                        <div class="form-group">
                            <div class="col-md-12 text-center">
                                <button type="submit" class="btn btn-primary btn-lg">Salvar</button>
                            </div>
                        </div>
                    </fieldset>
                </form>
            </div>

    </div>
       

    <script src="../js/jquery.min.js"></script>
    <script src="../js/bootstrap.min.js"></script>

    <!-- Custom JavaScript for the Side Menu and Smooth Scrolling -->
    <script>
    $("#menu-close").click(function(e) {
        e.preventDefault();
        $("#sidebar-wrapper").toggleClass("active");
    });
    </script>
    <script>
    $("#menu-toggle").click(function(e) {
        e.preventDefault();
        $("#sidebar-wrapper").toggleClass("active");
    });
    </script>
    <script>
    $(function() {
        $('a[href*=#]:not([href=#])').click(function() {
            if (location.pathname.replace(/^\//, '') == this.pathname.replace(/^\//, '') || location.hostname == this.hostname) {

                var target = $(this.hash);
                target = target.length ? target : $('[name=' + this.hash.slice(1) + ']');
                if (target.length) {
                    $('html,body').animate({
                        scrollTop: target.offset().top
                    }, 1000);
                    return false;
                }
            }
        });
    });
    </script>
    <!-- Função do sidebar pra mostrar/esconder subitens-->
    <script>
    $('ul.sidebar-nav li').click(function() {
  $(this).children('ul').toggle();
});
    </script>    

    </body>
</html>
<?php $database->disconnect();?>