<?PHP require "verifica.php"; 
include_once("MySQL.php");
include_once("Utils.php");
include_once("Malha.php");

$pasta_base = "arquivos/";
$nome_base = basename($_FILES["arquivo"]["name"]);
$nome_final = $pasta_base . $_SESSION["id"]."_".$nome_base;
$uploadOk = 1;
$tipo = pathinfo($nome_final,PATHINFO_EXTENSION);
$tamanho = 1024*1024*5;

// Verifica se já existe o arquivo com este nome
if (file_exists($nome_final)) {
    $_SESSION["mensagem"] = "Desculpe, o arquivo ja existe!";
    $uploadOk = 0;
}

// Verifica o tamanho
if ($_FILES["arquivo"]["size"] > $tamanho) {
    $_SESSION["mensagem"] = "O arquivo deve ser menor que 5mb.";
    $uploadOk = 0;
}

// Verifica o do nome do arquivo
if (strlen($nome_base) > 255) {
    $_SESSION["mensagem"] = "O nome do arquivo é muito grande.";
    $uploadOk = 0;
}

// Verifica o tamanho se for 0 o arquivo é inválido
if ($_FILES["arquivo"]["size"] == 0) {
    $_SESSION["mensagem"] = "Arquivo invalido.";
    $uploadOk = 0;
}

// Permite apenas .OFF
if($tipo != "off") {
    $_SESSION["mensagem"] = "O formato do arquivo deve ser .OFF.";
    $uploadOk = 0;
}
// Verifica se esta OK e não tem nenhum erro
if ($uploadOk > 0) {
    
    if (move_uploaded_file($_FILES["arquivo"]["tmp_name"], $nome_final)) 
    {
        $newMesh = new Malha();
        $utils = new Utils();
        $database = $utils->getDatabaseConnection();
        $database->connect();
        
        $newMesh->setNome($nome_base);
        $newMesh->setUsuario($_SESSION["id"]);

        $sql = "INSERT INTO MALHAS
              (NOME, USUARIO) 
              VALUES (
              '".$newMesh->getNome()."', 
              '".$newMesh->getUsuario()."'
              )";
              
        $database->executeCommand($sql);

        if($database->getAffectedRows() == 1)
            $_SESSION["mensagem"] = "Arquivo ".$nome_base." carregado com sucesso.";
        else
            $_SESSION["mensagem"] = $database->getError();

        $database->disconnect();
    } else {
        $_SESSION["mensagem"] = "Seu arquivo não foi carregado.";
    }
}


header("Location: carregar.php");
?>