<?php session_start(); ?>

<!--  
   Layout Baseado no exemplo de bootstrap encontrado em: http://getbootstrap.com/examples/cover/
   por @mdo
-->
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="Banca da disciplina de Projeto Final de Curso II, apresentada ao Curso de Sistemas de
    Informação da Universidade Estadual de Mato Grosso do Sul, como parte dos requisitos para a obtenção do título de Bacharel em Sistemas de Informação.">
    <meta name="author" content="Allan Henrique Paza">
    <link rel="icon" href="favicon.ico">

    <title>Aplicações WEB 3D com WEBGL: Visualizador de Malhas</title>
    <link href="css/bootstrap.min.css" rel="stylesheet">
    <link href="css/cover.css" rel="stylesheet">

  </head>

  <body>

    <div class="site-wrapper">

      <div class="site-wrapper-inner">

        <div class="cover-container">

          <div class="masthead clearfix">
            <div class="inner">
              <div class="masthead-brand">
              <img src="logo_uems.png" alt="UEMS" class="img-rounded" style="max-height: 50px;" >
              </div>
              <nav>
                <ul class="nav masthead-nav">
                  <li><a href="index.php">Inicio</a></li>
                  <li class="active"><a href="#">Visualizador</a></li>
                  <li><a href="contato.html">Contato</a></li>
                </ul>
              </nav>
            </div>
          </div>

          <div class="inner cover">
            <h1 class="cover-heading">Aplicações WEB 3D com WEBGL:</h1>
            <h2 class="heading">Visualizador de Malhas</h1>
            <?php 
              if(isset($_SESSION["id"]))
              { ?>
                <BR>
                <h3 class="heading">Você está logado como: <?php echo $_SESSION["nome"];?>,<a id="sair" href="server/sair.php">Sair</a></h1>
                <p class="lead">
                <a href="server/viewer.php" class="btn btn-lg btn-default">Visualizador</a>
                </p>
              <?php 
              }
              else
            {    
            ?>
            <p class="lead">
              <a href="server/login.php" class="btn btn-lg btn-default">Login</a>
            </p>
            <p class="lead">
              <a href="server/signup.php" class="btn btn-lg btn-default">Sign Up</a>
            </p>
            <?php 
            }?>
          </div>

          <div class="mastfoot">
            <div class="inner">
              <p>Acadêmico:<a href="mailto:allanpaza@gmail.com">Allan Henrique Paza</a>, Orientador: Msc.: <a href="mailto:diogo@comp.uems.br ">Diogo Fernando Trevisan</a>.</p>
            </div>
          </div>

        </div>

      </div>

    </div>

    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script src="js/jquery.min.js"></script>
    <script src="js/bootstrap.min.js"></script>
  </body>
</html>
